/* A simple server in the internet domain using TCP
   The port number is passed as an argument */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sstream>
#include <unistd.h>
#include <iostream>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <vector>
#include "Board.h"
#include "Engine.h"
using namespace std;

void error(const char *msg)
{
    perror(msg);
    exit(1);
}

int main(int argc, char *argv[])
{
     int sockfd, newsockfd, portno;
     socklen_t clilen;
    
	struct sockaddr_in serv_addr, cli_addr;

	int n;
    
	if (argc < 2) {
         fprintf(stderr,"ERROR, no port provided\n");
         exit(1);
     }
     
	 sockfd = socket(AF_INET, SOCK_STREAM, 0);
     
	 if (sockfd < 0) 
        error("ERROR opening socket");
     
	 bzero((char *) &serv_addr, sizeof(serv_addr));
     
	 portno = atoi(argv[1]);
     
	 serv_addr.sin_family = AF_INET;
     
	 serv_addr.sin_addr.s_addr = INADDR_ANY;
     
	 serv_addr.sin_port = htons(portno);
     
	 if (bind(sockfd, (struct sockaddr *) &serv_addr,
              sizeof(serv_addr)) < 0) 
              error("ERROR on binding");
     
	 listen(sockfd,5);
     
	 clilen = sizeof(cli_addr);
     
	 newsockfd = accept(sockfd, 
                 (struct sockaddr *) &cli_addr, 
                 &clilen);
     
	 if (newsockfd < 0) 
          error("ERROR on accept");
	
	//After all the server setup crap is done, we start the board
	
	// cout<<"WELCOME\n";
	
	// cout<<"1. Play against AI?\n";
	// cout<<"2. Play against a human?\n";
	// cout<<"Enter choice: \n";
	
	
	// cin >> choice;
	// cout << "OK" << endl;
	
	Engine e;
	//Board* temp = e.getBoard();
	//Board b = *temp;
	string move;
	
	//Brute force up in here!
	bool gameOver = false; 
	vector<Board> record;
	e.getBoard()->snapshot(record,(*e.getBoard()));
    char buffer[256];
    char info[256];
	int choice;
	int move_counter = 0;
	string final_move;
	
	write(newsockfd, "Select a choice:\n", 18);
	//Waiting for client to select game type
	n = read(newsockfd,info,255);
	istringstream convert(info);
	convert >> choice; //Sets choice equal to 1 or 2, based on clients input
	//cout << choice << "\n\n";
	bzero(info,256); //Resets info back to normal, "choice" now contains client's value
	
	 while(true) {
		 
		 while(gameOver != true)
		 {
			gameOver = e.getBoard()->isGameOver();
			
			while(e.getBoard()->getTurn() == 'O' )
			{
				e.getBoard()->displayBoard();//Display the board on the server
				string boardState = e.getBoard()->boardToString();
				//final_move = b.boardToString();
				write(newsockfd, boardState.c_str(), boardState.length());//Display the board to the client (line by line)
				cout<<"\nWaiting for client: ";
				n = read(newsockfd,buffer,255);
				move = buffer;
				cout << "\ntest" << move << "\n\n";
				e.getBoard()->interpret(move,(*e.getBoard()));
				gameOver = e.getBoard()->isGameOver();
				if(gameOver == true) {
					string endGame = "Game_Over";
					write(newsockfd, endGame.c_str(), endGame.length()); //Display the board to the client (line by line)
					break;
				}	
				else {
					string continueGame = "Continue_Game";
					write(newsockfd, continueGame.c_str(), continueGame.length()); //Display the board to the client (line by line)
					e.getBoard()->changeTurns();
				}
			}
			vector<moves> possibleMoves = e.getBoard()->viewPossibleMoves();
			if(choice == 1) {
				cout << "test\n\n";
				e.easyAI();
			}
				
		 }
		 /*
		string final_move = b.boardToString();
		write(newsockfd, final_move.c_str(), final_move.length());//Display the board to the client (line by line)
		write(newsockfd, final_move.c_str(), final_move.length());
		cout << "\n\nGAME OVER!!!";
		usleep(1);
		*/
		close(newsockfd);
		close(sockfd);
		
		break;
	 }
	 return 0; 
}
